c
c     Weak avalanche multiplication model, from Kloosterman and de Graaff
c
      subroutine AVALM(m,dmdvj,vj,pj,mj,av1,av2)
      double precision m,dmdvj,vj,pj,mj,av1,av2
      implicit double precision (a-z)
      dv=pj-vj
      sdv=sqrt(dv*dv+0.01d0)
      vl=0.5d0*(sdv+dv)
      dvl=-0.5d0*(1.0d0+dv/sdv)
      vlm=vl**(mj-1.0d0)
      ev=exp(-av2*vlm)
      ea=av1*ev
      m=vl*ea
      dmdvj=(ea-ea*av2*(mj-1.0d0)*vlm)*dvl
      return
      end
c
c     Version for self-heating, that also provides derivatives
c     w.r.t. pj and av2, which vary with temperature.
c
      subroutine AVALMt(m,dmdvj,dmdpj,dmdav2,vj,pj,mj,av1,av2)
      double precision m,dmdvj,dmdpj,dmdav2,vj,pj,mj,av1,av2
      implicit double precision (a-z)
      dv=pj-vj
      sdv=sqrt(dv*dv+0.01d0)
      vl=0.5d0*(sdv+dv)
      dvl=-0.5d0*(1.0d0+dv/sdv)
      vlm=vl**(mj-1.0d0)
      ev=exp(-av2*vlm)
      ea=av1*ev
      m=vl*ea
      dmdvj=(ea-ea*av2*(mj-1.0d0)*vlm)*dvl
      dmdpj=-dmdvj
      dmdav2=-m*vlm
      return
      end
