c
c	AC solver (very primitive) for VBIC95.
c	This program reads in a parameter list (in the order defined
c	in the model definition, from a file called PARS with entries
c	that are value/name pairs), and then reads Vc/Vb biases
c	from stdin and prints Ic/Ib and y-parameters (over f) to stdout.
c	A 2-port configuration with Ve=Vs=0 is assumed.
c	Please note that the resistances cannot be zero for this solver,
c	and that the solution strategy is a dumb, bounded NR.
c	Node ordering for solution is: bi ei ci cx bp bx si
c
	double precision p(200),pnom(200)
	implicit double precision (a-z)
	integer npar,nit,iargc,nargs,i,j,k,ipvt(9),ipvtGlu(9)
	double precision C7(7,7),G7(7,7),B(9,9),G(9,9)
	double precision Ginv(9,9),Glu(9,9),f(9),Fr(9),Fi(9)
	double precision xr(9),xi(9),BGinv(9,9),BGinvB(9,9)
	double precision Geff(9,9)
	character*20 parnam,arg
	open(31,file='PARS')
	npar=1
	ifirst=0
	rewind(31)
10	continue
	read(31,*,end=20) pnom(npar),parnam
	npar=npar+1
	goto 10
20	continue
	close(31)
	npar=npar-1
c
c	Abort if any resistances are too small
c
	if(pnom( 2).lt.1e-6) goto 1000
	if(pnom( 3).lt.1e-6) goto 1000
	if(pnom( 7).lt.1e-6) goto 1000
	if(pnom( 8).lt.1e-6) goto 1000
	if(pnom( 9).lt.1e-6) goto 1000
	if(pnom(10).lt.1e-6) goto 1000
	if(pnom(11).lt.1e-6) goto 1000
c
c	Call temperature mapping routine, TAMB can be changed
c	using the -t flag
c
	TAMB=27.0d0
	nargs=iargc()
	if (nargs.gt.1) then
	   call getarg(1,arg)
	   if (arg.eq."-t".and.nargs.ge.2) then
	      call getarg(2,arg)
	      read(arg,*) TAMB
	   endif
	endif
	call vbict(p,pnom,TAMB)
c
c	Inputs  are: v(c) v(b)
c	Outputs are: i(c) i(b)
c	             f y11 y12 y21 y22
c
	write(6,*) 'Inputs  are: v(c) v(b)'
	write(6,*) 'Outputs are: v(c) v(b) i(c) i(b) nit'
	write(6,*) '             f  beta y11 y12 y21 y22'
	SCALE=1.0d0
100	continue
	read(5,*,end=200) vce,vbe
	vse=0.0d0
	call solver_yp(vce,vbe,vse,p,ic,ib,ie,is,nit,SCALE,G7,C7)
	write(6,201) vce,vbe,ic,ib,nit
c
c	Set up matrices for AC solve, first G in (G+jB)X=F where
c	X is modified nodal, and includes Ib/Ic as unknowns
c
	do 101 i=1,7
	G(8,i)=0.0d0
	G(9,i)=0.0d0
	G(i,8)=0.0d0
	G(i,9)=0.0d0
	do 101 j=1,7
101	G(i,j)=G7(i,j)
	G(8,8)=1.0d0
	G(8,9)=0.0d0
	G(9,8)=0.0d0
	G(9,9)=1.0d0
	G(8,6)=1.0d0/p(7)
	G(9,4)=1.0d0/p(2)
	do 102 i=1,9
	do 102 j=1,9
102	Glu(i,j)=G(i,j)
	call decomp(Glu,9,ipvtGlu)
	do 105 j=1,9
		do 103 i=1,9
103		f(i)=0.0d0
		f(j)=1.0d0
		call solve(Glu,9,ipvtGlu,f)
		do 104 i=1,9
104		Ginv(i,j)=f(i)
105	continue
c
c	Now loop through frequencies, doing solves for Vb=1+j0 then
c	Vc=1+j0, which gives all y-parameters as Vb/Vc currents
c
	efreq=0.0d0
110	continue
	freq=10.0d0**efreq
	omega=2.0d0*3.141592654d0*freq
c
c	Form B and rhs for Vb=1+j0 and Vc=0+j0 (for y11 and y21)
c
	do 111 i=1,7
		Fr(i)=0.0d0
		Fi(i)=0.0d0
		B(8,i)=0.0d0
		B(9,i)=0.0d0
		B(i,8)=0.0d0
		B(i,9)=0.0d0
		do 111 j=1,7
			B(i,j)=omega*C7(i,j)
111	continue
	B(8,8)=0.0d0
	B(8,9)=0.0d0
	B(9,8)=0.0d0
	B(9,9)=0.0d0
	Fr(6)=-1.0d0/p(7)
	Fr(8)= 1.0d0/p(7)
	Fr(9)= 0.0d0
	Fi(8)= omega*(p(16)+p(21))
	Fi(9)=-omega*p(21)
c
c	Now solve complex system using real solves only
c
	do 113 i=1,9
	xr(i)=Fr(i)
	do 113 j=1,9
		BGinv(i,j)=0.0d0
		do 112 k=1,9
112		BGinv(i,j)=BGinv(i,j)+B(i,k)*Ginv(k,j)
		xr(i)=xr(i)+BGinv(i,j)*Fi(j)
113	continue
	do 115 i=1,9
	do 115 j=1,9
		BGinvB(i,j)=0.0d0
		do 114 k=1,9
114		BGinvB(i,j)=BGinvB(i,j)+BGinv(i,k)*B(k,j)
		Geff(i,j)=G(i,j)+BGinvB(i,j)
115	continue
	call decomp(Geff,9,ipvt)
	call solve(Geff,9,ipvt,xr)
	do 117 i=1,9
	xi(i)=Fi(i)
	do 117 j=1,9
		xi(i)=xi(i)-B(i,j)*xr(j)
117	continue
	call solve(Glu,9,ipvtGlu,xi)
c
c	finally pick off y-parameters, which are just the currents added
c	to the MNA as the voltage applied was 1+j0
c
	y11r=xr(8)
	y21r=xr(9)
	y11i=xi(8)
	y21i=xi(9)
c	write(6,*)
c	write(6,321) ((G(i,j),j=1,9),i=1,9)
c321	format(9(1pe10.2))
c	write(6,*)
c	write(6,400) xr(1),xi(1),Fr(1),Fi(1)
c	write(6,400) xr(2),xi(2),Fr(2),Fi(2)
c	write(6,400) xr(3),xi(3),Fr(3),Fi(3)
c	write(6,400) xr(4),xi(4),Fr(4),Fi(4)
c	write(6,400) xr(5),xi(5),Fr(5),Fi(5)
c	write(6,400) xr(6),xi(6),Fr(6),Fi(6)
c	write(6,400) xr(7),xi(7),Fr(7),Fi(7)
c	write(6,400) xr(8),xi(8),Fr(8),Fi(8)
c	write(6,400) xr(9),xi(9),Fr(9),Fi(9)
c400	format(4(1pe12.4))
c	write(6,*)
c	write(6,*) y11r,y11i
c	write(6,*) y21r,y21i
c
c	Now do the same thing for Vb=0+j0 and Vc=1+j0 excitation
c
	do 121 i=1,7
		Fr(i)=0.0d0
		Fi(i)=0.0d0
		B(8,i)=0.0d0
		B(9,i)=0.0d0
		B(i,8)=0.0d0
		B(i,9)=0.0d0
		do 121 j=1,7
			B(i,j)=omega*C7(i,j)
121	continue
	B(8,8)=0.0d0
	B(8,9)=0.0d0
	B(9,8)=0.0d0
	B(9,9)=0.0d0
	Fr(4)=-1.0d0/p(2)
	Fr(8)= 0.0d0
	Fr(9)= 1.0d0/p(2)
	Fi(8)=-omega*p(21)
	Fi(9)= omega*p(21)
c
c	Now solve complex system using real solves only
c
	do 123 i=1,9
	xr(i)=Fr(i)
	do 123 j=1,9
		BGinv(i,j)=0.0d0
		do 122 k=1,9
122		BGinv(i,j)=BGinv(i,j)+B(i,k)*Ginv(k,j)
		xr(i)=xr(i)+BGinv(i,j)*Fi(j)
123	continue
	do 125 i=1,9
	do 125 j=1,9
		BGinvB(i,j)=0.0d0
		do 124 k=1,9
124		BGinvB(i,j)=BGinvB(i,j)+BGinv(i,k)*B(k,j)
		Geff(i,j)=G(i,j)+BGinvB(i,j)
125	continue
	call decomp(Geff,9,ipvt)
	call solve(Geff,9,ipvt,xr)
	do 127 i=1,9
	xi(i)=Fi(i)
	do 127 j=1,9
		xi(i)=xi(i)-B(i,j)*xr(j)
127	continue
	call solve(Glu,9,ipvtGlu,xi)
c
c	finally pick off y-parameters, which are just the currents added
c	to the MNA as the voltage applied was 1+j0
c
	y12r=xr(8)
	y22r=xr(9)
	y12i=xi(8)
	y22i=xi(9)
	beta=sqrt((y21r*y21r+y21i*y21i)/(y11r*y11r+y11i*y11i))
	write(6,202) freq,beta,y11r,y11i,y12r,y12i,y21r,y21i,y22r,y22i
	efreq=efreq+0.1d0
	if(efreq.lt.9.00001d0)goto 110
	goto 100
200	continue
201	format(2(0pf7.3),2(1x,1pe11.3),i4)
202	format(2(1pe10.3),4(1x,'(',1pe10.3,',',1pe10.3')',))
c
c
c
1000	continue
	end
c
c	Primitive solver routine, for testing only
c
	subroutine solver_yp(vcet,vbet,vset,p,ic,ib,ie,is,nit,SCALE,
     +		GG,C)
	implicit double precision (a-z)
	integer nit,itmax,ipvt(7),ii,jj
	double precision v(7),G(7,7),C(7,7),rhs(7),p(200),GG(7,7)
c
c	Initialize internal node voltages
c
	v(1)=0.6
	v(2)=0.0
	v(3)=0.0
	v(4)=0.0
	v(5)=0.0
	v(6)=0.6
	v(7)=0.0
c
c	NR iteration loop
c
	nit=0
	itmax=200
	dvmax=0.2
	errtol=1.0e-6
10	continue
	Vbe =vbet
	Vbc =vbet-vcet
	Vbei=v(1)-v(2)
	Vbex=v(6)-v(2)
	Vbci=v(1)-v(3)
	Vrcx=vcet-v(4)
	Vrci=v(4)-v(3)
	Vrbx=vbet-v(6)
	Vrbi=v(6)-v(1)
	Vre =    -v(2)
	Vrs =vset-v(7)
	Vbep=v(6)-v(5)
	Vbcp=v(7)-v(5)
	Vrbp=v(4)-v(5)
	do 110 ii=1,7
		rhs(ii)=0.0
		do 105 jj=1,7
			G(ii,jj)=0.0
			C(ii,jj)=0.0
105		continue
110	continue
      call vbicfj(p,Vbe,Vbc,Vbei,Vbex,Vbci,Vrcx,Vrci,Vrbx,Vrbi,Vre,
     +Vrs,Vbep,Vbcp,Vrbp,
     +Itzf,Itzf_Vbei,Itzf_Vbci,
     +Itzr,Itzr_Vbei,Itzr_Vbci,
     +Ibe,Ibe_Vbei,Ibex,Ibex_Vbex,Ibc,Ibc_Vbci,Igc,Igc_Vbei,Igc_Vbci,
     +Ircx,Ircx_Vrcx,Irci,Irci_Vbci,Irci_Vrci,
     +Irbx,Irbx_Vrbx,Irbi,Irbi_Vrbi,Irbi_Vbei,Irbi_Vbci,
     +Ire,Ire_Vre,Irs,Irs_Vrs,
     +Iccp,Iccp_Vbep,Iccp_Vbcp,Iccp_Vbci,
     +Ibep,Ibep_Vbep,Ibcp,Ibcp_Vbcp,
     +Irbp,Irbp_Vrbp,Irbp_Vbep,Irbp_Vbci,
     +Qbeo,Qbeo_Vbe,Qbco,Qbco_Vbc,
     +Qbe,Qbe_Vbei,Qbe_Vbci,
     +Qbex,Qbex_Vbex,Qbc,Qbc_Vbci,
     +Qbcx,Qbcx_Vbci,Qbcx_Vrci,
     +Qbep,Qbep_Vbep,Qbep_Vbci,
     +Qbcp,Qbcp_Vbcp,SCALE)
c	write(6,*) 'Vbe/i/x',Vbe,Vbei,Vbex
c	write(6,*) 'Vbc/i/rcx',Vbc,Vbci,Vrcx
c	write(6,*) 'Vrbi/x/e',Vrbx,Vrbi,Vre
c	write(6,*) 'Vrs/p',Vrs,Vbep,Vbcp,Vrbp
c	write(6,*) 'Itzf',Itzf,Itzf_Vbei,Itzf_Vbci
c	write(6,*) 'Itzr',Itzr,Itzr_Vbei,Itzr_Vbci
c	write(6,*) 'Ibe',Ibe,Ibe_Vbei
c	write(6,*) 'Ibex',Ibex,Ibex_Vbex
c	write(6,*) 'Ibc',Ibc,Ibc_Vbci
c	write(6,*) 'Igc',Igc,Igc_Vbei,Igc_Vbci
c	write(6,*) 'Ircx',Ircx,Ircx_Vrcx
c	write(6,*) 'Irci',Irci,Irci_Vrci,Irci_Vbci
c	write(6,*) 'Irbx',Irbx,Irbx_Vrbx
c	write(6,*) 'Irbi',Irbi,Irbi_Vrbi,Irbi_Vbei,Irbi_Vbci
c	write(6,*) 'Ire',Ire,Ire_Vre
c	write(6,*) 'Irs',Irs,Irs_Vrs
c	write(6,*) 'Iccp',Iccp,Iccp_Vbep,Iccp_Vbci,Iccp_Vbcp
c	write(6,*) 'Ibep',Ibep,Ibep_Vbep
c	write(6,*) 'Ibcp',Ibcp,Ibcp_Vbcp
c	write(6,*) 'Irbp',Irbp,Irbp_Vrbp,Irbp_Vbep,Irbp_Vbci
c	write(6,*) 'Qbeo',Qbeo,Qbeo_Vbe
c	write(6,*) 'Qbco',Qbco,Qbco_Vbc
c	write(6,*) 'Qbe',Qbe,Qbe_Vbei,Qbe_Vbci
c	write(6,*) 'Qbex',Qbex,Qbex_Vbex
c	write(6,*) 'Qbc',Qbc,Qbc_Vbci
c	write(6,*) 'Qbcx',Qbcx,Qbcx_Vbci,Qbcx_Vrci
c	write(6,*) 'Qbep',Qbep,Qbep_Vbep,Qbep_Vbci
c	write(6,*) 'Qbcp',Qbcp,Qbcp_Vbcp
c
c	Stamp Itzf element (currents are positive flowing INTO node)
c
	rhs(3)=rhs(3)-Itzf
	G(3,1)=G(3,1)-Itzf_Vbei
	G(3,2)=G(3,2)+Itzf_Vbei
	G(3,1)=G(3,1)-Itzf_Vbci
	G(3,3)=G(3,3)+Itzf_Vbci
	rhs(2)=rhs(2)+Itzf
	G(2,1)=G(2,1)+Itzf_Vbei
	G(2,2)=G(2,2)-Itzf_Vbei
	G(2,1)=G(2,1)+Itzf_Vbci
	G(2,3)=G(2,3)-Itzf_Vbci
c
c	Stamp Itzr element
c
	rhs(3)=rhs(3)+Itzr
	G(3,1)=G(3,1)+Itzr_Vbei
	G(3,2)=G(3,2)-Itzr_Vbei
	G(3,1)=G(3,1)+Itzr_Vbci
	G(3,3)=G(3,3)-Itzr_Vbci
	rhs(2)=rhs(2)-Itzr
	G(2,1)=G(2,1)-Itzr_Vbei
	G(2,2)=G(2,2)+Itzr_Vbei
	G(2,1)=G(2,1)-Itzr_Vbci
	G(2,3)=G(2,3)+Itzr_Vbci
c
c	Stamp Ibe element
c
	rhs(1)=rhs(1)-Ibe
	G(1,1)=G(1,1)-Ibe_Vbei
	G(1,2)=G(1,2)+Ibe_Vbei
	rhs(2)=rhs(2)+Ibe
	G(2,1)=G(2,1)+Ibe_Vbei
	G(2,2)=G(2,2)-Ibe_Vbei
c
c	Stamp Ibex element
c
	rhs(6)=rhs(6)-Ibex
	G(6,6)=G(6,6)-Ibex_Vbex
	G(6,2)=G(6,2)+Ibex_Vbex
	rhs(2)=rhs(2)+Ibex
	G(2,6)=G(2,6)+Ibex_Vbex
	G(2,2)=G(2,2)-Ibex_Vbex
c
c	Stamp Ibc element
c
	rhs(1)=rhs(1)-Ibc
	G(1,1)=G(1,1)-Ibc_Vbci
	G(1,3)=G(1,3)+Ibc_Vbci
	rhs(3)=rhs(3)+Ibc
	G(3,1)=G(3,1)+Ibc_Vbci
	G(3,3)=G(3,3)-Ibc_Vbci
c
c	Stamp Igc element
c
	rhs(3)=rhs(3)-Igc
	G(3,1)=G(3,1)-Igc_Vbei
	G(3,2)=G(3,2)+Igc_Vbei
	G(3,1)=G(3,1)-Igc_Vbci
	G(3,3)=G(3,3)+Igc_Vbci
	rhs(1)=rhs(1)+Igc
	G(1,1)=G(1,1)+Igc_Vbei
	G(1,2)=G(1,2)-Igc_Vbei
	G(1,1)=G(1,1)+Igc_Vbci
	G(1,3)=G(1,3)-Igc_Vbci
c
c	Stamp Ircx element
c
	rhs(4)=rhs(4)+Ircx
	G(4,4)=G(4,4)-Ircx_Vrcx
c
c	Stamp Irci element
c
	rhs(4)=rhs(4)-Irci
	G(4,4)=G(4,4)-Irci_Vrci
	G(4,3)=G(4,3)+Irci_Vrci
	G(4,1)=G(4,1)-Irci_Vbci
	G(4,3)=G(4,3)+Irci_Vbci
	rhs(3)=rhs(3)+Irci
	G(3,4)=G(3,4)+Irci_Vrci
	G(3,3)=G(3,3)-Irci_Vrci
	G(3,1)=G(3,1)+Irci_Vbci
	G(3,3)=G(3,3)-Irci_Vbci
c
c	Stamp Irbx element
c
	rhs(6)=rhs(6)+Irbx
	G(6,6)=G(6,6)-Irbx_Vrbx
c
c	Stamp Irbi element
c
	rhs(6)=rhs(6)-Irbi
	G(6,6)=G(6,6)-Irbi_Vrbi
	G(6,1)=G(6,1)+Irbi_Vrbi
	G(6,1)=G(6,1)-Irbi_Vbei
	G(6,2)=G(6,2)+Irbi_Vbei
	G(6,1)=G(6,1)-Irbi_Vbci
	G(6,3)=G(6,3)+Irbi_Vbci
	rhs(1)=rhs(1)+Irbi
	G(1,6)=G(1,6)+Irbi_Vrbi
	G(1,1)=G(1,1)-Irbi_Vrbi
	G(1,1)=G(1,1)+Irbi_Vbei
	G(1,2)=G(1,2)-Irbi_Vbei
	G(1,1)=G(1,1)+Irbi_Vbci
	G(1,3)=G(1,3)-Irbi_Vbci
c
c	Stamp Ire element
c
	rhs(2)=rhs(2)+Ire
	G(2,2)=G(2,2)-Ire_Vre
c
c	Stamp Irs element
c
	rhs(7)=rhs(7)+Irs
	G(7,7)=G(7,7)-Irs_Vrs
c
c	Stamp Iccp element
c
	rhs(6)=rhs(6)-Iccp
	G(6,6)=G(6,6)-Iccp_Vbep
	G(6,5)=G(6,5)+Iccp_Vbep
	G(6,1)=G(6,1)-Iccp_Vbci
	G(6,3)=G(6,3)+Iccp_Vbci
	G(6,7)=G(6,7)-Iccp_Vbcp
	G(6,5)=G(6,5)+Iccp_Vbcp
	rhs(7)=rhs(7)+Iccp
	G(7,6)=G(7,6)+Iccp_Vbep
	G(7,5)=G(7,5)-Iccp_Vbep
	G(7,1)=G(7,1)+Iccp_Vbci
	G(7,3)=G(7,3)-Iccp_Vbci
	G(7,7)=G(7,7)+Iccp_Vbcp
	G(7,5)=G(7,5)-Iccp_Vbcp
c
c	Stamp Ibep element
c
	rhs(6)=rhs(6)-Ibep
	G(6,6)=G(6,6)-Ibep_Vbep
	G(6,5)=G(6,5)+Ibep_Vbep
	rhs(5)=rhs(5)+Ibep
	G(5,6)=G(5,6)+Ibep_Vbep
	G(5,5)=G(5,5)-Ibep_Vbep
c
c	Stamp Ibcp element
c
	rhs(7)=rhs(7)-Ibcp
	G(7,7)=G(7,7)-Ibcp_Vbcp
	G(7,5)=G(7,5)+Ibcp_Vbcp
	rhs(5)=rhs(5)+Ibcp
	G(5,7)=G(5,7)+Ibcp_Vbcp
	G(5,5)=G(5,5)-Ibcp_Vbcp
c
c	Stamp Irbp element
c
	rhs(4)=rhs(4)-Irbp
	G(4,4)=G(4,4)-Irbp_Vrbp
	G(4,5)=G(4,5)+Irbp_Vrbp
	G(4,6)=G(4,6)-Irbp_Vbep
	G(4,5)=G(4,5)+Irbp_Vbep
	G(4,1)=G(4,1)-Irbp_Vbci
	G(4,3)=G(4,3)+Irbp_Vbci
	rhs(5)=rhs(5)+Irbp
	G(5,4)=G(5,4)+Irbp_Vrbp
	G(5,5)=G(5,5)-Irbp_Vrbp
	G(5,6)=G(5,6)+Irbp_Vbep
	G(5,5)=G(5,5)-Irbp_Vbep
	G(5,1)=G(5,1)+Irbp_Vbci
	G(5,3)=G(5,3)-Irbp_Vbci
c
c	Now solve for update vector, limiting the norm of the
c	update vector to dvmax.
c
	fnorm=0
	do 50 ii=1,7
		fnorm=fnorm+rhs(ii)**2
50	continue
	fnorm=sqrt(fnorm)
	do 51 ii=1,7
	do 51 jj=1,7
51	GG(ii,jj)=G(ii,jj)
	call decomp(G,7,ipvt)
	call solve(G,7,ipvt,rhs)
	vscale=1.0
	do 55 ii=1,7
		if(abs(rhs(ii)/dvmax).gt.1.0/vscale)then
			vscale=abs(dvmax/rhs(ii))
		endif
55	continue
	dnorm=0
	do 60 ii=1,7
		rhs(ii)=rhs(ii)*vscale
		dnorm=dnorm+rhs(ii)**2
		v(ii)=v(ii)-rhs(ii)
60	continue
	dnorm=sqrt(dnorm)
	nit=nit+1
	if(nit.lt.itmax.and.fnorm.gt.errtol.and.dnorm.gt.errtol) goto 10
	ic=Itzf-Itzr-Ibc+Igc+Irbp
	ib=Ibe+Ibex+Ibc-Igc+Ibep+Iccp
	ie=-Itzf+Itzr-Ibe-Ibex
	is=-ic-ib-ie
c
c	Load capacitance matrix, Qbe element
c
	C(1,1)=C(1,1)-Qbe_Vbei
	C(1,2)=C(1,2)+Qbe_Vbei
	C(2,1)=C(2,1)+Qbe_Vbei
	C(2,2)=C(2,2)-Qbe_Vbei
	C(1,1)=C(1,1)-Qbe_Vbci
	C(1,3)=C(1,3)+Qbe_Vbci
	C(2,1)=C(2,1)+Qbe_Vbci
	C(2,3)=C(2,3)-Qbe_Vbci
c
c	Load capacitance matrix, Qbex element
c
	C(6,6)=C(6,6)-Qbex_Vbex
	C(6,2)=C(6,2)+Qbex_Vbex
	C(2,6)=C(2,6)+Qbex_Vbex
	C(2,2)=C(2,2)-Qbex_Vbex
c
c	Load capacitance matrix, Qbc element
c
	C(1,1)=C(1,1)-Qbc_Vbci
	C(1,3)=C(1,3)+Qbc_Vbci
	C(3,1)=C(3,1)+Qbc_Vbci
	C(3,3)=C(3,3)-Qbc_Vbci
c
c	Load capacitance matrix, Qbcx element
c
	C(1,1)=C(1,1)-Qbcx_Vbci
	C(1,3)=C(1,3)+Qbcx_Vbci
	C(4,1)=C(4,1)+Qbcx_Vbci
	C(4,3)=C(4,3)-Qbcx_Vbci
	C(1,4)=C(1,4)-Qbcx_Vrci
	C(1,3)=C(1,3)+Qbcx_Vrci
	C(4,4)=C(4,4)+Qbcx_Vrci
	C(4,3)=C(4,3)-Qbcx_Vrci
c
c	Load capacitance matrix, Qbep element
c
	C(6,6)=C(6,6)-Qbep_Vbep
	C(6,5)=C(6,5)+Qbep_Vbep
	C(5,6)=C(5,6)+Qbep_Vbep
	C(5,5)=C(5,5)-Qbep_Vbep
	C(6,1)=C(6,1)-Qbep_Vbci
	C(6,3)=C(6,3)+Qbep_Vbci
	C(5,1)=C(5,1)+Qbep_Vbci
	C(5,3)=C(5,3)-Qbep_Vbci
c
c	Load capacitance matrix, Qbcp element
c
	C(7,7)=C(7,7)-Qbcp_Vbcp
	C(7,5)=C(7,5)+Qbcp_Vbcp
	C(5,7)=C(5,7)+Qbcp_Vbcp
	C(5,5)=C(5,5)-Qbcp_Vbcp
c
c	Qbeo/Qbco are not loaded, as they are across external, not
c	internal, nodes. They must be taken into account in the terminal
c	y-parameter solver.
c
	return
	end
c
c	FMM forward decomposition and back substitution routines
c
	subroutine decomp(a,n,ipvt)
	double precision a(n,n)
	integer n,ipvt(n)
	integer nm1,k,kp1,m,i,j
	double precision t
	ipvt(n)=1
	nm1 = n-1
	do 35 k=1,nm1
		kp1=k+1
		m=k
		do 15 i=kp1,n
			if(abs(a(i,k)).gt.abs(a(m,k))) m=i
15		continue
		ipvt(k)=m
		if(m.ne.k) ipvt(n)=-ipvt(n)
		t=a(m,k)
		a(m,k)=a(k,k)
		a(k,k)=t
		if(t .eq. 0.0) then
			write(6,*) 'ZERO PIVOT'
			call exit(1)
		endif
		do 20 i=kp1,n
			a(i,k) = -a(i,k)/t
20		continue
		do 30 j=kp1,n
			t=a(m,j)
			a(m,j)=a(k,j)
			a(k,j)=t
			do 25 i=kp1,n
				a(i,j)=a(i,j)+a(i,k)*t
25			continue
30		continue
35	continue
	return
	end
	subroutine solve(a,n,ipvt,b)
	double precision a(n,n),b(n)
	integer n,ipvt(n)
	integer nm1,k,kp1,m,i,kb,km1
	double precision t
	nm1=n-1
	do 20 k=1,nm1
		kp1=k+1
		m=ipvt(k)
		t=b(m)
		b(m)=b(k)
		b(k)=t
		do 10 i=kp1,n
			b(i)=b(i)+a(i,k)*t
10		continue
20	continue
	do 40 kb=1,nm1
		km1=n-kb
		k=km1+1
		b(k)=b(k)/a(k,k)
		t=-b(k)
		do 30 i=1,km1
			b(i)=b(i)+a(i,k)*t
30		continue
40	continue
	b(1)=b(1)/a(1,1)
	return
	end
